﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Diagnostics;

public partial class VideoUpload : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    #region
    /// <summary>
    /// 视频格式转换
    /// </summary>
    /// <param name="FromName">原文件相对路径</param>
    /// <returns>转换后保存路径</returns>
    public string VideoConvertFlv(string FromName)
    {
        string ffmpeg = Server.MapPath(".") + " \\ffmpeg\\ffmpeg.exe";
        string ExportName = "flv" + "\\" + DateTime.Now.ToString("yyyyMMddhhmmss") + ".flv";
        string WidthAndHeight = "320x240";
        System.Diagnostics.ProcessStartInfo startInfo = new System.Diagnostics.ProcessStartInfo(ffmpeg);
        startInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
        startInfo.Arguments = " -i " + Server.MapPath(FromName) + " -ab 56 -ar 22050 -b 500 -r 15 -s " + WidthAndHeight + " " + Server.MapPath(ExportName);
        Process proc = Process.Start(startInfo);
        proc.WaitForExit();
        return ExportName  ;
 
    }
    /**/
    /// <summary>
    /// 从视频画面中截取一帧画面为图片
    /// </summary>
    /// <param name="VideoName">视频文件pic/guiyu.mov</param>
    /// <param name="WidthAndHeight">图片的尺寸如:240*180</param>
    /// <param name="CutTimeFrame">开始截取的时间如:"1"</param>
    /// <returns></returns>
    public string GetPicFromVideo(string VideoName, string WidthAndHeight, string CutTimeFrame)
    {

        string ffmpeg = Server.MapPath(".") + " \\ffmpeg\\ffmpeg.exe";
        string PicName = Server.MapPath("img\\" + DateTime.Now.ToString("yyyyMMddhhmmss") + ".jpg");
        System.Diagnostics.ProcessStartInfo startInfo = new System.Diagnostics.ProcessStartInfo(ffmpeg);
        startInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
        startInfo.Arguments = " -i " + Server.MapPath(VideoName) + " -y -f image2 -ss " + CutTimeFrame + " -t 0.001 -s " + WidthAndHeight + " " + PicName;
        try
        {
            Process proc = Process.Start(startInfo);
            proc.WaitForExit();
            return PicName;
        }
        catch (Exception err)
        {
            return err.Message;
        }
    }
    #endregion

    //例如转换wma格式文件
    protected void Button1_Click(object sender, EventArgs e)
    {
        string result = VideoConvertFlv("Upload\\1.wmv");
        Response.Write(result);
    }
    //截图
    protected void Button2_Click(object sender, EventArgs e)
    {
        string url = GetPicFromVideo("Upload\\1.wmv", "240*180", "1");
    }
}